// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "SimpleMouseDrawing.h"
#include "ChildView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildView

CChildView::CChildView()
{
	m_nShapeMode = LINE; 
	m_Color = RGB(255, 0, 0);
	m_nThickness = 1;
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_SHAPE_LINE, &CChildView::OnShapeLine)
	ON_COMMAND(ID_SHAPE_RECTANGLE, &CChildView::OnShapeRectangle)
	ON_COMMAND(ID_SHAPE_ELLIPSE, &CChildView::OnShapeEllipse)
	ON_COMMAND(ID_COLOR_RED, &CChildView::OnColorRed)
	ON_COMMAND(ID_COLOR_GREEN, &CChildView::OnColorGreen)
	ON_COMMAND(ID_COLOR_BLUE, &CChildView::OnColorBlue)
	ON_COMMAND(ID_COLOR_YELLOW, &CChildView::OnColorYellow)
	ON_COMMAND(ID_COLOR_PURPLE, &CChildView::OnColorPurple)
	ON_COMMAND(ID_COLOR_CYAN, &CChildView::OnColorCyan)
	ON_COMMAND(ID_THICKNESS_1, &CChildView::OnThickness1)
	ON_COMMAND(ID_THICKNESS_2, &CChildView::OnThickness2)
	ON_COMMAND(ID_THICKNESS_3, &CChildView::OnThickness3)
	ON_COMMAND(ID_THICKNESS_4, &CChildView::OnThickness4)
	ON_COMMAND(ID_THICKNESS_5, &CChildView::OnThickness5)
	ON_COMMAND(ID_LINE_BUTTON, &CChildView::OnShapeLine)
	ON_COMMAND(ID_RECTANGLE_BUTTON, &CChildView::OnShapeRectangle)
	ON_COMMAND(ID_ELLIPSE_BUTTON, &CChildView::OnShapeEllipse)
	ON_UPDATE_COMMAND_UI(ID_SHAPE_LINE, &CChildView::OnUpdateShapeLine)
	ON_UPDATE_COMMAND_UI(ID_SHAPE_RECTANGLE, &CChildView::OnUpdateShapeRectangle)
	ON_UPDATE_COMMAND_UI(ID_SHAPE_ELLIPSE, &CChildView::OnUpdateShapeEllipse)
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages
}


void CChildView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	SetCapture(); // MFC Լ ̿Ͽ 콺 ĸó Ѵ.
	// ׸ 忡 Ѵ.
	m_bDrawMode = TRUE; 
	// 콺 Ŀ ǥ Ѵ.
	m_ptStart = m_ptEnd = point; 
	
	CWnd::OnLButtonDown(nFlags, point);
}

void CChildView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CClientDC dc(this);
	dc.SelectStockObject(NULL_BRUSH);	

	CPen myPen, *pOldPen;   // ο     
	myPen.CreatePen(PS_SOLID, m_nThickness, m_Color); // Ķ    ü 
	pOldPen = dc.SelectObject(&myPen);	// DC ο  

	//   (,簢,Ÿ) ׸.
	dc.SetROP2(R2_COPYPEN); 
	if (m_nShapeMode == LINE) {
		dc.MoveTo(m_ptStart);
		dc.LineTo(m_ptEnd);
	}
	else if (m_nShapeMode == RECTANGLE) {
		dc.Rectangle(m_ptStart.x,m_ptStart.y,m_ptEnd.x,m_ptEnd.y);
	}
	else if (m_nShapeMode == ELLIPSE) {
		dc.Ellipse(m_ptStart.x,m_ptStart.y,m_ptEnd.x,m_ptEnd.y);
	}

	//dc.SelectObject(pOldPen); // DC   

	// ׸ 带 Ѵ.
	m_bDrawMode = FALSE;
	::ReleaseCapture(); //  API Լ Ͽ 콺 ĸó Ѵ.
	
	CWnd::OnLButtonUp(nFlags, point);
}

void CChildView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	// ׸ ̸   ׸⸦ ݺѴ.
	if(m_bDrawMode) { 
		CClientDC dc(this);
		dc.SelectStockObject(NULL_BRUSH);	

		CPen myPen, *pOldPen;   // ο     
		myPen.CreatePen(PS_SOLID, m_nThickness, m_Color); //  ü 
		pOldPen = dc.SelectObject(&myPen);	// DC ο  

		//  ׸  (,簢,Ÿ) .
		dc.SetROP2(R2_NOT); 
		if (m_nShapeMode == LINE) {
			dc.MoveTo(m_ptStart);
			dc.LineTo(m_ptEnd);
		}
		else if (m_nShapeMode == RECTANGLE) {
			dc.Rectangle(m_ptStart.x,m_ptStart.y,m_ptEnd.x,m_ptEnd.y);
		}
		else if (m_nShapeMode == ELLIPSE) {
			dc.Ellipse(m_ptStart.x,m_ptStart.y,m_ptEnd.x,m_ptEnd.y);
		}

		// ο  (,簢,Ÿ) ׸.
		dc.SetROP2(R2_NOT);
		if (m_nShapeMode == LINE) {
			dc.MoveTo(m_ptStart);
			dc.LineTo(point);
		}
		else if (m_nShapeMode == RECTANGLE) {
			dc.Rectangle(m_ptStart.x,m_ptStart.y,point.x,point.y);
		}
		else if (m_nShapeMode == ELLIPSE) {
			dc.Ellipse(m_ptStart.x,m_ptStart.y,point.x,point.y);
		}

		//dc.SelectObject(pOldPen); // DC   

		//   ǥ Ѵ.
		m_ptEnd = point; 
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: Add your message handler code here and/or call default
	if (nChar == VK_SPACE) {
		if (m_nShapeMode == LINE)
			m_nShapeMode = RECTANGLE;
		else if (m_nShapeMode == RECTANGLE)
			m_nShapeMode = ELLIPSE;
		else if (m_nShapeMode == ELLIPSE)
			m_nShapeMode = LINE;
	}
	Invalidate();

	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CChildView::OnShapeLine()
{
	// TODO: Add your command handler code here
	m_nShapeMode = LINE;

	// if new shape mode is selected, update the status bar text
	CMainFrame *pFrame = (CMainFrame *) AfxGetMainWnd();
	CString strStatus;
	strStatus.Format("Shape : LINE");
  
	Invalidate();
}

void CChildView::OnShapeRectangle()
{
	// TODO: Add your command handler code here
	m_nShapeMode = RECTANGLE;

	// if new shape mode is selected, update the status bar text
	CMainFrame *pFrame = (CMainFrame *)AfxGetMainWnd();
	CString strStatus;
	strStatus.Format("Shape : RECTANGLE");
  
	Invalidate();
}

void CChildView::OnShapeEllipse()
{
	// TODO: Add your command handler code here
	m_nShapeMode = ELLIPSE;

	// if new shape mode is selected, update the status bar text
	CMainFrame *pFrame = (CMainFrame *)AfxGetMainWnd();
	CString strStatus;
	strStatus.Format("Shape : ELLIPSE");
  
	Invalidate();
}

void CChildView::OnColorRed()
{
	// TODO: Add your command handler code here
	m_Color = RGB(255, 0, 0);
}

void CChildView::OnColorGreen()
{
	// TODO: Add your command handler code here
	m_Color = RGB(0, 255, 0);
}

void CChildView::OnColorBlue()
{
	// TODO: Add your command handler code here
	m_Color = RGB(0, 0, 255);
}

void CChildView::OnColorYellow()
{
	// TODO: Add your command handler code here
	m_Color = RGB(255, 255, 0);
}

void CChildView::OnColorPurple()
{
	// TODO: Add your command handler code here
	m_Color = RGB(255, 0, 255);
}

void CChildView::OnColorCyan()
{
	// TODO: Add your command handler code here
	m_Color = RGB(0, 255, 255);
}

void CChildView::OnThickness1()
{
	// TODO: Add your command handler code here
	m_nThickness = 1;
}

void CChildView::OnThickness2()
{
	// TODO: Add your command handler code here
	m_nThickness = 2;
}

void CChildView::OnThickness3()
{
	// TODO: Add your command handler code here
	m_nThickness = 3;
}

void CChildView::OnThickness4()
{
	// TODO: Add your command handler code here
	m_nThickness = 4;
}

void CChildView::OnThickness5()
{
	// TODO: Add your command handler code here
	m_nThickness = 5;
}

void CChildView::OnUpdateShapeLine(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
    pCmdUI->SetCheck(m_nShapeMode == LINE);
}

void CChildView::OnUpdateShapeRectangle(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
    pCmdUI->SetCheck(m_nShapeMode == RECTANGLE);
}

void CChildView::OnUpdateShapeEllipse(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
    pCmdUI->SetCheck(m_nShapeMode == ELLIPSE);
}
